﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var Config = (function () {
    function Config() {
    }
    Config.RootUrl = '.';
    Config.LoadOggs = false;
    Config.HidePurchases = false;
    return Config;
})();

var GlobalInfo = (function () {
    function GlobalInfo() {
    }
    GlobalInfo.GetSpellStripCount = function () {
        return parseInt(localStorage['SpellStripCount']) || 0;
    };

    GlobalInfo.SetSpellStripCount = function (value) {
        localStorage['SpellStripCount'] = value;
    };

    GlobalInfo.GetSpellFreezeTimeCount = function () {
        return parseInt(localStorage['SpellFreezeTimeCount']) || 0;
    };

    GlobalInfo.SetSpellFreezeTimeCount = function (value) {
        localStorage['SpellFreezeTimeCount'] = value;
    };

    GlobalInfo.AddDonateCount = function () {
        var count = localStorage['DonateCount'] || 0;
        count++;

        localStorage['DonateCount'] = count;
    };

    GlobalInfo.Init = function () {
        this.GirlsCount = 0;
        this.Points = 0;
        this.Level = null;
    };

    GlobalInfo.GetBestScoreGirlsCount = function () {
        var i = parseInt(localStorage['BestScoreGirlsCount']);

        if (!i)
            return 0;

        return i;
    };
    GlobalInfo.GetBestScorePoints = function () {
        var i = parseInt(localStorage['BestScorePoints']);

        if (!i)
            return 0;

        return i;
    };
    GlobalInfo.GetLevel = function () {
        return new GameLevel(localStorage['LevelID'], 0, localStorage['LevelName'], '');
    };

    GlobalInfo.SaveBestScores = function () {
        if (this.GetBestScoreGirlsCount() < GlobalInfo.GirlsCount)
            localStorage['BestScoreGirlsCount'] = GlobalInfo.GirlsCount;

        if (this.GetBestScorePoints() < GlobalInfo.GirlsCount)
            localStorage['BestScorePoints'] = GlobalInfo.Points;

        if (this.Level) {
            var oldLevelID = localStorage['LevelID'];
            var oldLevelName = localStorage['LevelName'];

            if (!oldLevelID || this.Level.ID >= oldLevelID) {
                localStorage['LevelID'] = this.Level.ID;
                localStorage['LevelName'] = this.Level.Name;
            }
        }

        Extensions.SubmitLeaderboardScore(this.GetBestScoreGirlsCount());
    };
    GlobalInfo.GirlsCount = 0;
    GlobalInfo.Points = 0;
    return GlobalInfo;
})();

var GameLevel = (function () {
    function GameLevel(ID, GirlsCount, Name, AudioName) {
        this.ID = ID;
        this.GirlsCount = GirlsCount;
        this.Name = Name;
        this.AudioName = AudioName;
    }
    return GameLevel;
})();

var Extensions = (function () {
    function Extensions() {
    }
    Extensions.ShowLeaderboard = function (data) {
    };

    Extensions.ShowShare = function (message) {
    };

    Extensions.DonateMe = function (successCallback) {
        successCallback && successCallback();
    };

    Extensions.BuyFreezeTime = function (count, successCallback) {
        successCallback && successCallback();
    };

    Extensions.BuyStrip = function (count, successCallback) {
        successCallback && successCallback();
    };

    Extensions.SubmitLeaderboardScore = function (count) {
    };
    return Extensions;
})();

var Game = (function (_super) {
    __extends(Game, _super);
    function Game() {
        _super.call(this, 664, 1180, Phaser.CANVAS, 'GameContainer', null);

        this.state.add('Start', Start, true);
        this.state.add('Level', Level, false);
        this.state.add('GameResults', GameResults, false);
    }
    Game.prototype.boot = function () {
        _super.prototype.boot.call(this);

        this.stage.setBackgroundColor('#FFF');
        this.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
        this.scale.setScreenSize(true);
    };
    return Game;
})(Phaser.Game);

var Start = (function (_super) {
    __extends(Start, _super);
    function Start() {
        _super.apply(this, arguments);
    }
    Start.prototype.preload = function () {
        var imagesRoot = Config.RootUrl + '/Images/';
        var audiosRoot = Config.RootUrl + '/Audios/';

        this.load.image('Body1', imagesRoot + 'Bodies/1.png');
        this.load.image('Body1_bk', imagesRoot + 'Bodies/1_bk.png');
        this.load.image('Body1_br', imagesRoot + 'Bodies/1_br.png');
        this.load.image('Body2', imagesRoot + 'Bodies/2.png');
        this.load.image('Body2_bk', imagesRoot + 'Bodies/2_bk.png');
        this.load.image('Body2_br', imagesRoot + 'Bodies/2_br.png');
        this.load.image('Body3', imagesRoot + 'Bodies/3.png');
        this.load.image('Body3_bk', imagesRoot + 'Bodies/3_bk.png');
        this.load.image('Body3_br', imagesRoot + 'Bodies/3_br.png');
        this.load.image('Body4', imagesRoot + 'Bodies/4.png');
        this.load.image('Body4_bk', imagesRoot + 'Bodies/4_bk.png');
        this.load.image('Body4_br', imagesRoot + 'Bodies/4_br.png');
        this.load.image('Body5', imagesRoot + 'Bodies/5.png');
        this.load.image('Body5_bk', imagesRoot + 'Bodies/5_bk.png');
        this.load.image('Body5_br', imagesRoot + 'Bodies/5_br.png');
        this.load.image('Body6', imagesRoot + 'Bodies/6.png');
        this.load.image('Body6_bk', imagesRoot + 'Bodies/6_bk.png');
        this.load.image('Body6_br', imagesRoot + 'Bodies/6_br.png');
        this.load.image('Body7', imagesRoot + 'Bodies/7.png');
        this.load.image('Body7_bk', imagesRoot + 'Bodies/7_bk.png');
        this.load.image('Body7_br', imagesRoot + 'Bodies/7_br.png');
        this.load.image('Body8', imagesRoot + 'Bodies/8.png');
        this.load.image('Body8_bk', imagesRoot + 'Bodies/8_bk.png');
        this.load.image('Body8_br', imagesRoot + 'Bodies/8_br.png');

        this.load.image('Bottom1', imagesRoot + 'Bottoms/bell_bottoms.png');
        this.load.image('Bottom2', imagesRoot + 'Bottoms/check_pants.png');
        this.load.image('Bottom3', imagesRoot + 'Bottoms/leggings_shiny.png');
        this.load.image('Bottom4', imagesRoot + 'Bottoms/suit_soft.png');
        this.load.image('Bottom5', imagesRoot + 'Bottoms/chino_pants.png');
        this.load.image('Bottom6', imagesRoot + 'Bottoms/culotte_balloon.png');
        this.load.image('Bottom7', imagesRoot + 'Bottoms/culotte_pants.png');
        this.load.image('Bottom8', imagesRoot + 'Bottoms/culotte_short.png');
        this.load.image('Bottom9', imagesRoot + 'Bottoms/flare_pants.png');
        this.load.image('Bottom10', imagesRoot + 'Bottoms/half_pants.png');
        this.load.image('Bottom11', imagesRoot + 'Bottoms/jeans_slim.png');
        this.load.image('Bottom12', imagesRoot + 'Bottoms/jeans_slim_col.png');
        this.load.image('Bottom13', imagesRoot + 'Bottoms/jeans_slim_mono.png');
        this.load.image('Bottom14', imagesRoot + 'Bottoms/jeans_straight.png');
        this.load.image('Bottom15', imagesRoot + 'Bottoms/seven_cargo.png');
        this.load.image('Bottom16', imagesRoot + 'Bottoms/seven_pants.png');
        this.load.image('Bottom17', imagesRoot + 'Bottoms/skinny_denim.png');
        this.load.image('Bottom18', imagesRoot + 'Bottoms/skinny_panther.png');
        this.load.image('Bottom19', imagesRoot + 'Bottoms/suit_pants.png');
        this.load.image('Bottom20', imagesRoot + 'Bottoms/sweat_pants.png');

        this.load.image('Glasses1', imagesRoot + 'Glasses/33.png');
        this.load.image('Glasses2', imagesRoot + 'Glasses/15.png');

        this.load.image('Brow1', imagesRoot + 'Brows/1.png');
        this.load.image('Brow2', imagesRoot + 'Brows/2.png');
        this.load.image('Brow3', imagesRoot + 'Brows/3.png');
        this.load.image('Brow4', imagesRoot + 'Brows/4.png');
        this.load.image('Brow5', imagesRoot + 'Brows/5.png');
        this.load.image('Brow6', imagesRoot + 'Brows/6.png');
        this.load.image('Brow7', imagesRoot + 'Brows/7.png');
        this.load.image('Brow8', imagesRoot + 'Brows/8.png');
        this.load.image('Brow9', imagesRoot + 'Brows/9.png');
        this.load.image('Brow10', imagesRoot + 'Brows/10.png');
        this.load.image('Brow11', imagesRoot + 'Brows/32.png');
        this.load.image('Brow12', imagesRoot + 'Brows/12.png');
        this.load.image('Brow13', imagesRoot + 'Brows/13.png');
        this.load.image('Brow14', imagesRoot + 'Brows/14.png');
        this.load.image('Brow15', imagesRoot + 'Brows/15.png');
        this.load.image('Brow16', imagesRoot + 'Brows/16.png');
        this.load.image('Brow17', imagesRoot + 'Brows/17.png');
        this.load.image('Brow18', imagesRoot + 'Brows/18.png');
        this.load.image('Brow19', imagesRoot + 'Brows/19.png');
        this.load.image('Brow20', imagesRoot + 'Brows/20.png');
        this.load.image('Brow21', imagesRoot + 'Brows/24.png');
        this.load.image('Brow22', imagesRoot + 'Brows/22.png');
        this.load.image('Brow23', imagesRoot + 'Brows/23.png');

        this.load.image('EyeClosed', imagesRoot + 'Eyes/0.png');
        this.load.image('EyeWink1', imagesRoot + 'Eyes/0_1.png');
        this.load.image('EyeWink2', imagesRoot + 'Eyes/0_2.png');
        this.load.image('Eye1', imagesRoot + 'Eyes/1.png');
        this.load.image('Eye2', imagesRoot + 'Eyes/2.png');
        this.load.image('Eye3', imagesRoot + 'Eyes/3.png');
        this.load.image('Eye4', imagesRoot + 'Eyes/4.png');
        this.load.image('Eye5', imagesRoot + 'Eyes/5.png');
        this.load.image('Eye6', imagesRoot + 'Eyes/6.png');
        this.load.image('Eye7', imagesRoot + 'Eyes/7.png');
        this.load.image('Eye8', imagesRoot + 'Eyes/8.png');
        this.load.image('Eye9', imagesRoot + 'Eyes/41.png');
        this.load.image('Eye10', imagesRoot + 'Eyes/13.png');
        this.load.image('Eye11', imagesRoot + 'Eyes/14.png');
        this.load.image('Eye12', imagesRoot + 'Eyes/15.png');
        this.load.image('Eye13', imagesRoot + 'Eyes/16.png');
        this.load.image('Eye14', imagesRoot + 'Eyes/17.png');
        this.load.image('Eye15', imagesRoot + 'Eyes/18.png');
        this.load.image('Eye16', imagesRoot + 'Eyes/19.png');
        this.load.image('Eye17', imagesRoot + 'Eyes/44.png');
        this.load.image('Eye18', imagesRoot + 'Eyes/43.png');
        this.load.image('Eye19', imagesRoot + 'Eyes/38.png');
        this.load.image('Eye20', imagesRoot + 'Eyes/39.png');
        this.load.image('Eye21', imagesRoot + 'Eyes/42.png');
        this.load.image('Eye1_bk', imagesRoot + 'Eyes/1.png');
        this.load.image('Eye2_bk', imagesRoot + 'Eyes/2.png');
        this.load.image('Eye3_bk', imagesRoot + 'Eyes/4.png');
        this.load.image('Eye4_bk', imagesRoot + 'Eyes/6.png');
        this.load.image('Eye5_bk', imagesRoot + 'Eyes/8.png');
        this.load.image('Eye6_bk', imagesRoot + 'Eyes/10.png');

        this.load.image('Face1', imagesRoot + 'Faces/1.png');
        this.load.image('Face1_bk', imagesRoot + 'Faces/1_bk.png');
        this.load.image('Face1_br', imagesRoot + 'Faces/1_br.png');
        this.load.image('Face2', imagesRoot + 'Faces/2.png');
        this.load.image('Face2_bk', imagesRoot + 'Faces/2_bk.png');
        this.load.image('Face2_br', imagesRoot + 'Faces/2_br.png');
        this.load.image('Face3', imagesRoot + 'Faces/3.png');
        this.load.image('Face3_bk', imagesRoot + 'Faces/3_bk.png');
        this.load.image('Face3_br', imagesRoot + 'Faces/3_br.png');
        this.load.image('Face4', imagesRoot + 'Faces/4.png');
        this.load.image('Face4_bk', imagesRoot + 'Faces/4_bk.png');
        this.load.image('Face4_br', imagesRoot + 'Faces/4_br.png');

        this.load.image('Hair1', imagesRoot + 'Hairs/Arrange/1.png');
        this.load.image('Hair2', imagesRoot + 'Hairs/Arrange/2.png');
        this.load.image('Hair3', imagesRoot + 'Hairs/Arrange/3.png');
        this.load.image('Hair4', imagesRoot + 'Hairs/Arrange/4.png');
        this.load.image('Hair5', imagesRoot + 'Hairs/Arrange/5.png');
        this.load.image('Hair6', imagesRoot + 'Hairs/Arrange/6.png');
        this.load.image('Hair7', imagesRoot + 'Hairs/Arrange/7.png');
        this.load.image('Hair8', imagesRoot + 'Hairs/Arrange/8.png');
        this.load.image('Hair9', imagesRoot + 'Hairs/Arrange/9.png');
        this.load.image('Hair10', imagesRoot + 'Hairs/Arrange/10.png');
        this.load.image('Hair11', imagesRoot + 'Hairs/Arrange/11.png');
        this.load.image('Hair12', imagesRoot + 'Hairs/Arrange/12.png');
        this.load.image('Hair13', imagesRoot + 'Hairs/Arrange/13.png');
        this.load.image('Hair14', imagesRoot + 'Hairs/Arrange/14.png');
        this.load.image('Hair15', imagesRoot + 'Hairs/Arrange/15.png');
        this.load.image('Hair16', imagesRoot + 'Hairs/Arrange/16.png');
        this.load.image('Hair17', imagesRoot + 'Hairs/Arrange/17.png');
        this.load.image('Hair18', imagesRoot + 'Hairs/Arrange/18.png');
        this.load.image('Hair19', imagesRoot + 'Hairs/Arrange/19.png');
        this.load.image('Hair20', imagesRoot + 'Hairs/Arrange/20.png');
        this.load.image('Hair21', imagesRoot + 'Hairs/Arrange/21.png');
        this.load.image('Hair22', imagesRoot + 'Hairs/Long/1.png');
        this.load.image('Hair23', imagesRoot + 'Hairs/Long/2.png');
        this.load.image('Hair24', imagesRoot + 'Hairs/Long/3.png');
        this.load.image('Hair25', imagesRoot + 'Hairs/Long/4.png');
        this.load.image('Hair26', imagesRoot + 'Hairs/Long/5.png');
        this.load.image('Hair27', imagesRoot + 'Hairs/Long/6.png');
        this.load.image('Hair28', imagesRoot + 'Hairs/Long/7.png');
        this.load.image('Hair29', imagesRoot + 'Hairs/Long/8.png');
        this.load.image('Hair30', imagesRoot + 'Hairs/Long/9.png');
        this.load.image('Hair31', imagesRoot + 'Hairs/Long/10.png');
        this.load.image('Hair32', imagesRoot + 'Hairs/Long/11.png');
        this.load.image('Hair33', imagesRoot + 'Hairs/Long/12.png');
        this.load.image('Hair34', imagesRoot + 'Hairs/Long/13.png');
        this.load.image('Hair35', imagesRoot + 'Hairs/Long/14.png');
        this.load.image('Hair36', imagesRoot + 'Hairs/Long/15.png');
        this.load.image('Hair37', imagesRoot + 'Hairs/Long/16.png');
        this.load.image('Hair38', imagesRoot + 'Hairs/Long/17.png');
        this.load.image('Hair39', imagesRoot + 'Hairs/Long/18.png');
        this.load.image('Hair40', imagesRoot + 'Hairs/Long/19.png');
        this.load.image('Hair41', imagesRoot + 'Hairs/Long/20.png');
        this.load.image('Hair42', imagesRoot + 'Hairs/Long/21.png');
        this.load.image('Hair43', imagesRoot + 'Hairs/Long/22.png');
        this.load.image('Hair44', imagesRoot + 'Hairs/Long/23.png');
        this.load.image('Hair45', imagesRoot + 'Hairs/Long/24.png');
        this.load.image('Hair46', imagesRoot + 'Hairs/Long/25.png');
        this.load.image('Hair47', imagesRoot + 'Hairs/Long/26.png');
        this.load.image('Hair48', imagesRoot + 'Hairs/Long/27.png');

        this.load.image('Hat1', imagesRoot + 'Hats/knit_ear_cap.png');
        this.load.image('Hat2', imagesRoot + 'Hats/knit_pattern_cap.png');
        this.load.image('Hat3', imagesRoot + 'Hats/bowler_hat.png');
        this.load.image('Hat4', imagesRoot + 'Hats/casq_soft.png');
        this.load.image('Hat5', imagesRoot + 'Hats/fedora_hat.png');
        this.load.image('Hat6', imagesRoot + 'Hats/knit_beret.png');
        this.load.image('Hat7', imagesRoot + 'Hats/knit_cap.png');
        this.load.image('Hat8', imagesRoot + 'Hats/kurosshe_hat.png');
        this.load.image('Hat9', imagesRoot + 'Hats/marin_cap.png');
        this.load.image('Hat10', imagesRoot + 'Hats/mesh_cap.png');
        this.load.image('Hat11', imagesRoot + 'Hats/santa.png');
        this.load.image('Hat12', imagesRoot + 'Hats/silk_hat.png');
        this.load.image('Hat13', imagesRoot + 'Hats/soft_beret.png');
        this.load.image('Hat14', imagesRoot + 'Hats/soft_cap.png');

        this.load.image('Item1', imagesRoot + 'Items/1.png');
        this.load.image('Item2', imagesRoot + 'Items/5.png');

        this.load.image('Mouth1', imagesRoot + 'Mouths/1.png');
        this.load.image('Mouth2', imagesRoot + 'Mouths/2.png');
        this.load.image('Mouth3', imagesRoot + 'Mouths/3.png');
        this.load.image('Mouth4', imagesRoot + 'Mouths/4.png');
        this.load.image('Mouth5', imagesRoot + 'Mouths/15.png');
        this.load.image('Mouth6', imagesRoot + 'Mouths/6.png');
        this.load.image('Mouth7', imagesRoot + 'Mouths/16.png');
        this.load.image('Mouth8', imagesRoot + 'Mouths/21.png');
        this.load.image('Mouth9', imagesRoot + 'Mouths/9.png');
        this.load.image('Mouth10', imagesRoot + 'Mouths/10.png');
        this.load.image('Mouth11', imagesRoot + 'Mouths/11.png');
        this.load.image('Mouth12', imagesRoot + 'Mouths/12.png');
        this.load.image('Mouth13', imagesRoot + 'Mouths/13.png');
        this.load.image('Mouth1_1', imagesRoot + 'Mouths/37.png');
        this.load.image('Mouth2_1', imagesRoot + 'Mouths/38.png');
        this.load.image('Mouth3_1', imagesRoot + 'Mouths/39.png');
        this.load.image('Mouth4_1', imagesRoot + 'Mouths/40.png');
        this.load.image('Mouth5_1', imagesRoot + 'Mouths/41.png');
        this.load.image('Mouth6_1', imagesRoot + 'Mouths/42.png');
        this.load.image('Mouth7_1', imagesRoot + 'Mouths/43.png');
        this.load.image('Mouth8_1', imagesRoot + 'Mouths/44.png');
        this.load.image('Mouth9_1', imagesRoot + 'Mouths/45.png');
        this.load.image('Mouth10_1', imagesRoot + 'Mouths/46.png');

        this.load.image('Outer1', imagesRoot + 'Outers/2.png');
        this.load.image('Outer2', imagesRoot + 'Outers/cdg_spring.png');
        this.load.image('Outer3', imagesRoot + 'Outers/jacket_nocollar.png');
        this.load.image('Outer4', imagesRoot + 'Outers/jacket_suit_2d.png');
        this.load.image('Outer5', imagesRoot + 'Outers/bls_nocollar.png');
        this.load.image('Outer6', imagesRoot + 'Outers/fur_down_vest.png');
        this.load.image('Outer7', imagesRoot + 'Outers/fur_leather_jacket.png');
        this.load.image('Outer8', imagesRoot + 'Outers/fur_vest.png');
        this.load.image('Outer9', imagesRoot + 'Outers/jacket_mouton.png');
        this.load.image('Outer10', imagesRoot + 'Outers/jacket_nobutton.png');
        this.load.image('Outer11', imagesRoot + 'Outers/jacket_uneck.png');
        this.load.image('Outer12', imagesRoot + 'Outers/shirt_flower.png');
        this.load.image('Outer13', imagesRoot + 'Outers/sweat_parka.png');
        this.load.image('Outer14', imagesRoot + 'Outers/sweat_parka_nozip.png');
        this.load.image('Outer15', imagesRoot + 'Outers/sweat_short.png');

        this.load.image('Scarf1', imagesRoot + 'Scarfs/1.png');

        this.load.image('Top1', imagesRoot + 'Tops/1.png');
        this.load.image('Top2', imagesRoot + 'Tops/cami_short.png');
        this.load.image('Top3', imagesRoot + 'Tops/cami_vneck.png');
        this.load.image('Top4', imagesRoot + 'Tops/knit_warm_snow.png');
        this.load.image('Top5', imagesRoot + 'Tops/long_t_thick.png');
        this.load.image('Top6', imagesRoot + 'Tops/cami_neck_dot.png');
        this.load.image('Top7', imagesRoot + 'Tops/cami_wide_peke.png');
        this.load.image('Top8', imagesRoot + 'Tops/cutsew_basic.png');
        this.load.image('Top9', imagesRoot + 'Tops/cutsew_dot.png');
        this.load.image('Top10', imagesRoot + 'Tops/cutsew_natural.png');
        this.load.image('Top11', imagesRoot + 'Tops/cutsew_no_rib.png');
        this.load.image('Top12', imagesRoot + 'Tops/cutsew_tropical.png');
        this.load.image('Top13', imagesRoot + 'Tops/knit_high_neck.png');
        this.load.image('Top14', imagesRoot + 'Tops/knit_u_frill.png');
        this.load.image('Top15', imagesRoot + 'Tops/knit_u_sweater.png');
        this.load.image('Top16', imagesRoot + 'Tops/knit_warm_neck.png');
        this.load.image('Top17', imagesRoot + 'Tops/knit_warm_snow.png');
        this.load.image('Top18', imagesRoot + 'Tops/long_t_border.png');
        this.load.image('Top19', imagesRoot + 'Tops/long_t_cosmos.png');
        this.load.image('Top20', imagesRoot + 'Tops/long_t_heart.png');
        this.load.image('Top21', imagesRoot + 'Tops/long_t_snow.png');
        this.load.image('Top22', imagesRoot + 'Tops/long_t_thick.png');
        this.load.image('Top23', imagesRoot + 'Tops/long_t_triangle.png');
        this.load.image('Top24', imagesRoot + 'Tops/long_t_u.png');
        this.load.image('Top25', imagesRoot + 'Tops/t_border.png');
        this.load.image('Top26', imagesRoot + 'Tops/t_des.png');
        this.load.image('Top27', imagesRoot + 'Tops/t_face.png');
        this.load.image('Top28', imagesRoot + 'Tops/t_nurse.png');
        this.load.image('Top29', imagesRoot + 'Tops/t_woman.png');
        this.load.image('Top30', imagesRoot + 'Tops/tanktop_heart.png');
        this.load.image('Top31', imagesRoot + 'Tops/tanktop_panther.png');
        this.load.image('Top32', imagesRoot + 'Tops/tanktop_star.png');
        this.load.image('Top33', imagesRoot + 'Tops/ut_heart.png');
        this.load.image('Top34', imagesRoot + 'Tops/ut_rose.png');
        this.load.image('Top35', imagesRoot + 'Tops/ut_stripes.png');

        this.load.image('DropHat', imagesRoot + 'Drops/bkr_hat.png');
        this.load.image('DropOuter', imagesRoot + 'Drops/bkr_outer.png');
        this.load.image('DropPants', imagesRoot + 'Drops/bkr_bottom.png');
        this.load.image('DropTop', imagesRoot + 'Drops/bkr_top.png');

        this.load.spritesheet('SpellFreezeTime', imagesRoot + 'Spells/timer.png', 100, 100);
        this.load.spritesheet('SpellStrip', imagesRoot + 'Spells/user.png', 100, 100);

        this.load.image('HelpPointer', imagesRoot + 'pointer.png');
        this.load.image('GameBackground', imagesRoot + 'game_bg.png');
        this.load.image('LogoGirl', imagesRoot + 'logo_girl.png');
        this.load.spritesheet('Leaderboard', imagesRoot + 'leaderboard.png', 400, 284);
        this.load.spritesheet('DonateMe', imagesRoot + 'donate_me.png', 200, 139);
        this.load.spritesheet('Share', imagesRoot + 'share.png', 400, 284);

        this.load.audio('win2', !Config.LoadOggs ? [audiosRoot + 'victory.mp3'] : [audiosRoot + 'victory.mp3', audiosRoot + 'victory.ogg']);
        this.load.audio('lose', !Config.LoadOggs ? [audiosRoot + 'loser.mp3'] : [audiosRoot + 'loser.mp3', audiosRoot + 'loser.ogg']);
        this.load.audio('warning', !Config.LoadOggs ? [audiosRoot + 'wong_answer.mp3'] : [audiosRoot + 'wong_answer.mp3', audiosRoot + 'wong_answer.ogg']);
        this.load.audio('correct', !Config.LoadOggs ? [audiosRoot + 'correct_answer.mp3'] : [audiosRoot + 'correct_answer.mp3', audiosRoot + 'correct_answer.ogg']);
        this.load.audio('tick', !Config.LoadOggs ? [audiosRoot + 'time_ticking.mp3'] : [audiosRoot + 'time_ticking.mp3', audiosRoot + 'time_ticking.ogg']);
        this.load.audio('strip', !Config.LoadOggs ? [audiosRoot + 'strip2.mp3'] : [audiosRoot + 'strip2.mp3', audiosRoot + 'strip2.ogg']);
        this.load.audio('finish', !Config.LoadOggs ? [audiosRoot + 'finish.mp3'] : [audiosRoot + 'finish.mp3', audiosRoot + 'finish.ogg']);

        this.load.audio('SpellFreeze', !Config.LoadOggs ? [audiosRoot + 'spell_freeze.mp3'] : [audiosRoot + 'spell_freeze.mp3', audiosRoot + 'spell_freeze.ogg']);
        this.load.audio('SpellStrip', !Config.LoadOggs ? [audiosRoot + 'spell_strip.mp3'] : [audiosRoot + 'spell_strip.mp3', audiosRoot + 'spell_strip.ogg']);

        this.load.audio('LevelGoodLooking', !Config.LoadOggs ? [audiosRoot + 'Levels/GoodLooking.mp3'] : [audiosRoot + 'Levels/GoodLooking.mp3', audiosRoot + 'Levels/GoodLooking.ogg']);
        this.load.audio('LevelDapper', !Config.LoadOggs ? [audiosRoot + 'Levels/Dapper.mp3'] : [audiosRoot + 'Levels/Dapper.mp3', audiosRoot + 'Levels/Dapper.ogg']);
        this.load.audio('LevelCool', !Config.LoadOggs ? [audiosRoot + 'Levels/Cool.mp3'] : [audiosRoot + 'Levels/Cool.mp3', audiosRoot + 'Levels/Cool.ogg']);
        this.load.audio('LevelHandsome', !Config.LoadOggs ? [audiosRoot + 'Levels/Handsome.mp3'] : [audiosRoot + 'Levels/Handsome.mp3', audiosRoot + 'Levels/Handsome.ogg']);
        this.load.audio('LevelStylish', !Config.LoadOggs ? [audiosRoot + 'Levels/Stylish.mp3'] : [audiosRoot + 'Levels/Stylish.mp3', audiosRoot + 'Levels/Stylish.ogg']);
        this.load.audio('LevelGraceful', !Config.LoadOggs ? [audiosRoot + 'Levels/Graceful.mp3'] : [audiosRoot + 'Levels/Graceful.mp3', audiosRoot + 'Levels/Graceful.ogg']);
        this.load.audio('LevelSexy1', !Config.LoadOggs ? [audiosRoot + 'Levels/Sexy.mp3'] : [audiosRoot + 'Levels/Sexy.mp3', audiosRoot + 'Levels/Sexy.ogg']);
        this.load.audio('LevelSexy2', !Config.LoadOggs ? [audiosRoot + 'Levels/Sexy2.mp3'] : [audiosRoot + 'Levels/Sexy2.mp3']);
        this.load.audio('LevelSmooth', !Config.LoadOggs ? [audiosRoot + 'Levels/Smooth.mp3'] : [audiosRoot + 'Levels/Smooth.mp3', audiosRoot + 'Levels/Smooth.ogg']);
        this.load.audio('LevelAttractive', !Config.LoadOggs ? [audiosRoot + 'Levels/Attractive.mp3'] : [audiosRoot + 'Levels/Attractive.mp3', audiosRoot + 'Levels/Attractive.ogg']);
        this.load.audio('LevelFashionable', !Config.LoadOggs ? [audiosRoot + 'Levels/Fashionable.mp3'] : [audiosRoot + 'Levels/Fashionable.mp3', audiosRoot + 'Levels/Fashionable.ogg']);
        this.load.audio('LevelElegant', !Config.LoadOggs ? [audiosRoot + 'Levels/Elegant.mp3'] : [audiosRoot + 'Levels/Elegant.mp3', audiosRoot + 'Levels/Elegant.ogg']);
        this.load.audio('LevelImpressive', !Config.LoadOggs ? [audiosRoot + 'Levels/Impressive.mp3'] : [audiosRoot + 'Levels/Impressive.mp3', audiosRoot + 'Levels/Impressive.ogg']);
        this.load.audio('LevelMajestic', !Config.LoadOggs ? [audiosRoot + 'Levels/Majestic.mp3'] : [audiosRoot + 'Levels/Majestic.mp3', audiosRoot + 'Levels/Majestic.ogg']);
        this.load.audio('LevelMacho', !Config.LoadOggs ? [audiosRoot + 'Levels/Macho.mp3'] : [audiosRoot + 'Levels/Macho.mp3', audiosRoot + 'Levels/Macho.ogg']);
        this.load.audio('LevelSexSymbol', !Config.LoadOggs ? [audiosRoot + 'Levels/SexSymbol.mp3'] : [audiosRoot + 'Levels/SexSymbol.mp3', audiosRoot + 'Levels/SexSymbol.ogg']);
    };

    Start.prototype.create = function () {
        var _this = this;
        var startButton = this.add.text(this.world.width / 2, this.world.height / 2 + 200, 'TAP THE GIRL TO START PLAYING', '');
        startButton.anchor.set(0.5, 0.5);
        startButton.fill = 'black';
        startButton.alpha = 0.3;
        startButton.fontSize = 30;
        startButton.font = 'Tahoma';

        var level = GlobalInfo.GetLevel();
        if (level.ID) {
            var leaderboard = this.add.button(this.world.width / 2, this.world.height / 2 + 420, 'Leaderboard', function () {
            }, this, 1, 0, 1, 0);
            leaderboard.anchor.setTo(0.5, 0.5);
            leaderboard.events.onInputDown.add(function () {
                Extensions.ShowLeaderboard('all');
                return false;
            });

            var levelName = this.add.text(this.world.width / 2, this.world.height / 2 - 400, level.Name, '');
            levelName.anchor.set(0.5, 0.5);
            levelName.fill = '#55b919';
            levelName.fontSize = 50;
            levelName.font = 'Tahoma';

            var levelTitle = this.add.text(this.world.width / 2, this.world.height / 2 - 345, 'LEVEL ' + level.ID, '');
            levelTitle.anchor.set(0.5, 0.5);
            levelTitle.fill = 'black';
            levelTitle.fontSize = 25;
            levelTitle.font = 'Tahoma';
            levelTitle.alpha = 0.3;

            var bestScoreTitle = this.add.text(this.world.width / 2, this.world.height / 2 + 320, 'BEST SCORE:', '');
            bestScoreTitle.anchor.set(0.5, 0.5);
            bestScoreTitle.fill = 'black';
            bestScoreTitle.fontSize = 25;
            bestScoreTitle.font = 'Tahoma';
            bestScoreTitle.alpha = 0.6;

            var scoreTitle = this.add.text(this.world.width / 2 - 130, this.world.height / 2 + 406, 'STRIPPED', '');
            scoreTitle.font = 'Tahoma';
            scoreTitle.fontSize = 25;
            scoreTitle.fill = 'black';
            scoreTitle.anchor.set(0, 0);
            scoreTitle.alpha = 0.3;

            var scoreTitle = this.add.text(this.world.width / 2 + 130, this.world.height / 2 + 400, GlobalInfo.GetBestScoreGirlsCount().toString(), '');
            scoreTitle.font = 'Tahoma';
            scoreTitle.fontSize = 35;
            scoreTitle.fill = '#55b919';
            scoreTitle.anchor.set(1, 0);
        }

        var logoGirl = this.add.image(this.world.width / 2, this.world.height / 2 - 50, 'LogoGirl');
        logoGirl.anchor.set(0.5, 0.5);
        logoGirl.inputEnabled = true;
        logoGirl.scale.setTo(1, 1);
        logoGirl.alpha = 0;
        this.game.add.tween(logoGirl).to({ alpha: 1 }, 1000).start();

        logoGirl.events.onInputDown.add(function () {
            logoGirl.inputEnabled = false;

            _this.game.add.tween(logoGirl.scale).to({ x: 3, y: 3 }, 700, null, true);
            setTimeout(function () {
                return _this.game.state.start('Level', true, false);
            }, 600);
        });
    };
    return Start;
})(Phaser.State);

var Level = (function (_super) {
    __extends(Level, _super);
    function Level() {
        _super.apply(this, arguments);
        this.TOTAL_TIME = 60;
        this.personParts = [];
        this.secondsLeft = this.TOTAL_TIME;
        this.goodMovesCount = 0;
        this.gameLevel1GirlsCount = 9;
        this.gameLevel2GirlsCount = 1000;
        this.isFinished = false;
        this.spellFreezeTimePrice = 500;
        this.spellStripPrice = 200;
        this.freezeTimeUsedCount = 0;
        this.stripUsedCount = 0;
        this.spellsStartedShowing = false;
    }
    Level.prototype.init = function (isPlayAgain) {
        this.isPlayAgain = isPlayAgain;
    };

    Level.prototype.create = function () {
        var _this = this;
        this.isFinished = false;
        GlobalInfo.Init();

        this.spellFreezeTime = this.add.button(20, this.world.height - 30, 'SpellFreezeTime', this.castFreezeTime, this, 1, 0, 2, 0);
        this.spellFreezeTime.anchor.setTo(0, 1);
        this.spellFreezeTime.inputEnabled = false;
        this.spellFreezeTime.alpha = 0.3;
        this.spellFreezeTime.visible = false;

        this.spellStrip = this.add.button(this.world.width - 20, this.world.height - 30, 'SpellStrip', this.castStrip, this, 1, 0, 1, 0);
        this.spellStrip.anchor.setTo(1, 1);
        this.spellStrip.inputEnabled = false;
        this.spellStrip.alpha = 0.3;
        this.spellStrip.visible = false;

        this.spellFreezeTimePriceTitle = this.add.text(70, this.world.height - 25, this.spellFreezeTimePrice + ' Points', '');
        this.spellFreezeTimePriceTitle.anchor.set(0.5, 0);
        this.spellFreezeTimePriceTitle.fill = 'orange';
        this.spellFreezeTimePriceTitle.font = 'Tahoma';
        this.spellFreezeTimePriceTitle.fontSize = 20;
        this.spellFreezeTimePriceTitle.visible = false;

        this.spellStripPriceTitle = this.add.text(this.world.width - 70, this.world.height - 25, this.spellStripPrice + ' Points', '');
        this.spellStripPriceTitle.anchor.set(0.5, 0);
        this.spellStripPriceTitle.fill = 'orange';
        this.spellStripPriceTitle.font = 'Tahoma';
        this.spellStripPriceTitle.fontSize = 20;
        this.spellStripPriceTitle.visible = false;

        this.spellFreezeTimePurchasedCountLabel = this.add.text(95, this.world.height - 55, GlobalInfo.GetSpellFreezeTimeCount() ? GlobalInfo.GetSpellFreezeTimeCount().toString() : '', '');
        this.spellFreezeTimePurchasedCountLabel.anchor.set(0.5, 0.5);
        this.spellFreezeTimePurchasedCountLabel.fill = 'white';
        this.spellFreezeTimePurchasedCountLabel.setShadow(0, 0, 'rgba(0,0,0,0.9)', 10);
        this.spellFreezeTimePurchasedCountLabel.visible = false;

        this.spellStripPurchasedCountLabel = this.add.text(this.world.width - 40, this.world.height - 55, GlobalInfo.GetSpellStripCount() ? GlobalInfo.GetSpellStripCount().toString() : '', '');
        this.spellStripPurchasedCountLabel.anchor.set(0.5, 0.5);
        this.spellStripPurchasedCountLabel.fill = 'white';
        this.spellStripPurchasedCountLabel.setShadow(0, 0, 'rgba(0,0,0,0.9)', 10);
        this.spellStripPurchasedCountLabel.visible = false;

        this.girlsText = this.add.text(this.world.width - 10, 70, '0', '');
        this.girlsText.font = 'Tahoma';
        this.girlsText.fontSize = 40;
        this.girlsText.fontWeight = 500;
        this.girlsText.fill = 'black';

        this.girlsText.anchor.set(1, 0);
        this.girlsText.visible = false;

        this.pointsText = this.add.text(this.world.width - 10, 20, '0', '');
        this.pointsText.font = 'Tahoma';
        this.pointsText.fontSize = 40;
        this.pointsText.fontWeight = 500;
        this.pointsText.fill = 'orange';

        this.pointsText.anchor.set(1, 0);
        this.pointsText.visible = false;

        this.pointsCoefTitle = this.add.text(this.world.width - 230, 20, '2X', '');
        this.pointsCoefTitle.font = 'Tahoma';
        this.pointsCoefTitle.fontSize = 37;
        this.pointsCoefTitle.fontWeight = 500;
        this.pointsCoefTitle.fill = 'black';
        this.pointsCoefTitle.anchor.set(0, 0);
        this.pointsCoefTitle.alpha = 0.8;

        this.timeText = this.add.text(this.world.width / 2, 20, 'STRIP HER!', '');
        this.timeText.font = 'Tahoma';
        this.timeText.fontSize = 50;
        this.timeText.fontWeight = 100;
        this.timeText.fill = 'black';
        this.timeText.anchor.set(0.5, 0);

        this.levelText = this.add.text(20, 20, '', '');
        this.levelText.font = 'Tahoma';
        this.levelText.fontSize = 40;
        this.levelText.fontWeight = 100;
        this.levelText.fill = '#55b919';
        this.levelText.anchor.set(0, 0);

        this.centerCountingLabel = this.add.text(this.world.width / 2, 160, '', '');
        this.centerCountingLabel.anchor.set(0.5, 0.5);
        this.centerCountingLabel.scale.setTo(1, 1);
        this.centerCountingLabel.fontSize = 40;
        this.levelText.font = 'Tahoma';
        this.centerCountingLabel.fill = '#55b919';

        this.levels = [
            new GameLevel(1, 2, 'Good Looking', 'LevelGoodLooking'),
            new GameLevel(2, 4, 'Dapper', 'LevelDapper'),
            new GameLevel(3, 6, 'Cool', 'LevelCool'),
            new GameLevel(4, 9, 'Handsome', 'LevelHandsome'),
            new GameLevel(5, 12, 'Stylish', 'LevelStylish'),
            new GameLevel(6, 16, 'Graceful', 'LevelGraceful'),
            new GameLevel(7, 21, 'Sexy', 'LevelSexy'),
            new GameLevel(8, 26, 'Smooth', 'LevelSmooth'),
            new GameLevel(9, 32, 'Attractive', 'LevelAttractive'),
            new GameLevel(10, 38, 'Fashionable', 'LevelFashionable'),
            new GameLevel(11, 45, 'Elegant', 'LevelElegant'),
            new GameLevel(12, 52, 'Impressive', 'LevelImpressive'),
            new GameLevel(13, 60, 'Majestic', 'LevelMajestic'),
            new GameLevel(14, 69, 'Macho', 'LevelMacho'),
            new GameLevel(15, 78, 'Sex Symbol', 'LevelSexSymbol')
        ];

        this.pointsTitle = this.add.text(this.world.width - 180, 27, 'POINTS', '');
        this.pointsTitle.font = 'Tahoma';
        this.pointsTitle.fontSize = 25;
        this.pointsTitle.fill = 'black';
        this.pointsTitle.anchor.set(0, 0);
        this.pointsTitle.alpha = 0.3;
        this.pointsTitle.visible = false;

        this.girlsTitle = this.add.text(this.world.width - 180, 77, 'STRIPPED', '');
        this.girlsTitle.font = 'Tahoma';
        this.girlsTitle.fontSize = 25;
        this.girlsTitle.fill = 'black';
        this.girlsTitle.anchor.set(0, 0);
        this.girlsTitle.alpha = 0.3;
        this.girlsTitle.visible = false;

        this.levelTitle = this.add.text(20, 65, '', '');
        this.levelTitle.font = 'Tahoma';
        this.levelTitle.fontSize = 25;
        this.levelTitle.fill = 'black';
        this.levelTitle.anchor.set(0, 0);
        this.levelTitle.alpha = 0.3;

        this.HelpPointer = this.add.image(0, 0, 'HelpPointer');
        this.HelpPointer.visible = false;
        this.HelpPointer.z = 1000;

        this.dropObjects = this.add.group();
        this.dropObjects.z = 5;

        this.audioWin1 = this.add.audio('correct', 0.5, false);
        this.audioWin2 = this.add.audio('correct', 0.5, false);
        this.audioLose = this.add.audio('lose', 0.5, false);
        this.audioWarning = this.add.audio('warning', 0.5, false);
        this.audioTick = this.add.audio('tick', 0.5, false);
        this.audioFinish = this.add.audio('finish', 0.5, false);
        this.audioSpellFreeze = this.add.audio('SpellFreeze', 0.5, false);
        this.audioSpellStrip = this.add.audio('SpellStrip', 0.5, false);

        this.eyesBlinkingAnimation = setInterval(function () {
            var rand = new Random().Next(10);
            var mode = 0;

            if (rand == 1 || rand == 2)
                mode = rand;

            _this.blinkEyes(mode);
        }, 3000);

        this.buildPlayer();

        this.setPointsCoef(1);
        this.goodMovesCount = 0;

        this.personParts.forEach(function (p) {
            p.alpha = 0;
            _this.game.add.tween(p).to({ alpha: 1 }, 100, null, true);
        });

        this.dropObjects.alpha = 0;
        this.game.add.tween(this.dropObjects).to({ alpha: 0.8 }, 400, null, true, 100);

        this.isFinished = true;

        setTimeout(this.start.bind(this), 0);
    };

    Level.prototype.start = function () {
        var _this = this;
        this.isFinished = false;

        this.freezeTimeUsedCount = 0;
        this.spellsStartedShowing = false;

        this.finishInterval = setInterval(function () {
            _this.secondsLeft--;
            _this.updateTimeLeft();

            if (_this.secondsLeft == 0) {
                _this.finish();
                _this.audioFinish.play();
            }
        }, 1000);
    };

    Level.prototype.updateTimeLeft = function () {
        var text = this.secondsLeft.toString();

        if (this.secondsLeft >= 60) {
            text = (this.secondsLeft - 60).toString();
        }

        if (text.length == 1)
            text = '0' + text;

        this.timeText.setText('0' + Math.floor(this.secondsLeft / 60) + ':' + text);
        if (this.secondsLeft <= 5 && this.secondsLeft > 0) {
            this.timeText.fill = 'red';
            this.audioTick.play();
        } else {
            this.timeText.fill = '#a7a7a6';
        }
    };

    Level.prototype.animateScaling = function (data, finishCallback) {
        this.centerCountingLabel.scale.setTo(1, 1);
        this.centerCountingLabel.alpha = 1;
        this.centerCountingLabel.text = data;

        this.game.add.tween(this.centerCountingLabel.scale).to({ x: 2, y: 2 }, 1000, null, true);
        this.game.add.tween(this.centerCountingLabel).to({ alpha: 0 }, 1000, null, true).onComplete.add(finishCallback);
    };

    Level.prototype.buildDropIcons = function () {
        var dropCoordinates = [];

        var index1, index2, index3, index4, index5, index6, rand;

        if (GlobalInfo.GirlsCount <= this.gameLevel1GirlsCount) {
            dropCoordinates.push(new Phaser.Point(30, this.world.height / 2), new Phaser.Point(this.world.width - 130, this.world.height / 2));

            rand = this.random(2);

            if (rand == 1) {
                index1 = 0;
                index2 = 1;
            } else {
                index1 = 1;
                index2 = 0;
            }

            this.dropTop = this.add.sprite(dropCoordinates[index1].x, dropCoordinates[index1].y, 'DropTop');
            this.dropBottom = this.add.sprite(dropCoordinates[index2].x, dropCoordinates[index2].y, 'DropPants');

            this.dropObjects.add(this.dropTop);
            this.dropObjects.add(this.dropBottom);

            return;
        }

        if (true || GlobalInfo.GirlsCount <= this.gameLevel2GirlsCount) {
            dropCoordinates.push(new Phaser.Point(30, this.world.height / 2 - 200), new Phaser.Point(30, this.world.height / 2 + 200), new Phaser.Point(this.world.width - 130, this.world.height / 2 - 200), new Phaser.Point(this.world.width - 130, this.world.height / 2 + 200));

            rand = this.random(4);

            if (rand == 1) {
                index1 = 0;
                index2 = 1;
                index3 = 2;
                index4 = 3;
            } else if (rand == 2) {
                index1 = 2;
                index2 = 0;
                index3 = 3;
                index4 = 1;
            } else if (rand == 3) {
                index1 = 3;
                index2 = 2;
                index3 = 0;
                index4 = 1;
            } else {
                index1 = 2;
                index2 = 3;
                index3 = 1;
                index4 = 0;
            }

            this.dropTop = this.add.sprite(dropCoordinates[index1].x, dropCoordinates[index1].y, 'DropTop');
            this.dropBottom = this.add.sprite(dropCoordinates[index2].x, dropCoordinates[index2].y, 'DropPants');
            this.dropHat = this.add.sprite(dropCoordinates[index3].x, dropCoordinates[index3].y, 'DropHat');
            this.dropOuter = this.add.sprite(dropCoordinates[index4].x, dropCoordinates[index4].y, 'DropOuter');

            this.dropObjects.add(this.dropTop);
            this.dropObjects.add(this.dropBottom);
            this.dropObjects.add(this.dropHat);
            this.dropObjects.add(this.dropOuter);

            return;
        }
    };

    Level.prototype.buildPlayer = function () {
        if (this.personParts && this.personParts.length) {
            this.personParts.forEach(function (p) {
                return p.destroy(true);
            });
        }

        this.buildDropIcons();

        var marginLeft = 100;
        var marginTop = 110;

        var skinColor = '';
        var skinColorRandom = this.random(4);
        if (skinColorRandom == 3 || skinColorRandom == 4)
            skinColor = '_br';
        if (skinColorRandom == 5)
            skinColor = '_bk';

        this.personBody = new PersonPart(this.game, marginLeft + 80, marginTop + 390, 2, 'Body' + this.random(8) + skinColor);
        this.personBottom = new PersonPart(this.game, marginLeft + 80, marginTop + 670, 5, 'Bottom' + this.random(20), true, this.dropBottom, this.HelpPointer, this.checkFinishGirl.bind(this), this.moveFailed.bind(this));
        this.personTop = new PersonPart(this.game, marginLeft + 80, marginTop + 406, 6, 'Top' + this.random(35), true, this.dropTop, this.HelpPointer, this.checkFinishGirl.bind(this), this.moveFailed.bind(this));
        this.personFace = new PersonPart(this.game, marginLeft + 80, marginTop + 140, 13, 'Face' + this.random(4) + skinColor);
        this.personHair = new PersonPart(this.game, marginLeft + 80, marginTop + 60, 15, 'Hair' + this.random(48));
        this.personEye = new PersonPart(this.game, marginLeft + 80, marginTop + 280, 14, 'Eye' + (skinColor == '_bk' ? this.random(6).toString() + skinColor : this.random(21).toString()));
        this.personMouth = new PersonPart(this.game, marginLeft + 80, marginTop + 350, 14, 'Mouth' + (GlobalInfo.GirlsCount > this.gameLevel1GirlsCount ? this.random(10).toString() + '_1' : this.random(13).toString()));
        this.personBrow = new PersonPart(this.game, marginLeft + 80, marginTop + 260, 14, 'Brow' + this.random(23));

        this.personParts.push(this.personBody, this.personTop, this.personBottom, this.personFace, this.personHair, this.personEye, this.personMouth, this.personBrow);

        if (GlobalInfo.GirlsCount > this.gameLevel1GirlsCount) {
            this.personOuter = new PersonPart(this.game, marginLeft + 80, marginTop + 406, 12, 'Outer' + this.random(15), true, this.dropOuter, this.HelpPointer, this.checkFinishGirl.bind(this), this.moveFailed.bind(this));
            this.personHat = new PersonPart(this.game, marginLeft + 80, marginTop + 26, 16, 'Hat' + this.random(14), true, this.dropHat, this.HelpPointer, this.checkFinishGirl.bind(this), this.moveFailed.bind(this));

            this.personParts.push(this.personOuter, this.personHat);
        }

        if (GlobalInfo.GirlsCount > this.gameLevel2GirlsCount) {
            this.personGlasses = new PersonPart(this.game, marginLeft + 80, marginTop + 280, 5, 'Glasses' + this.random(2), true, this.dropGlasses, this.HelpPointer, this.checkFinishGirl.bind(this), this.moveFailed.bind(this));
            this.personScarf = new PersonPart(this.game, marginLeft + 80, marginTop + 406, 15, 'Scarf1', true, this.dropScarf, this.HelpPointer, this.checkFinishGirl.bind(this), this.moveFailed.bind(this));

            this.personParts.push(this.personGlasses, this.personScarf);
        }

        this.HelpPointer.z = 1000;
        this.world.sort();
    };

    Level.prototype.moveFailed = function () {
        this.goodMovesCount = 0;
        this.setPointsCoef(1);
    };

    Level.prototype.castFreezeTime = function () {
        this.spellFreezeTime.inputEnabled = false;
        this.spellFreezeTime.alpha = 0.3;

        if (GlobalInfo.Points > this.spellFreezeTimePrice) {
            GlobalInfo.Points -= this.spellFreezeTimePrice;
            this.pointsText.setText(GlobalInfo.Points.toString());
        } else {
            var count = GlobalInfo.GetSpellFreezeTimeCount();
            count--;
            if (count < 0)
                return;

            this.spellFreezeTimePurchasedCountLabel.text = count > 0 ? count.toString() : '';

            GlobalInfo.SetSpellFreezeTimeCount(count);
        }

        this.secondsLeft += 10;
        this.freezeTimeUsedCount++;

        this.updateTimeLeft();

        this.audioSpellFreeze.play();

        this.animatePoint(10, this.world.height - 160, '+10 Sec.', true);
    };

    Level.prototype.castStrip = function () {
        this.spellFreezeTime.inputEnabled = false;
        this.spellFreezeTime.alpha = 0.3;

        var objects = this.personParts.filter(function (p) {
            return p.isDragable && p.alive;
        });
        if (objects.length <= 3)
            return;

        if (GlobalInfo.Points > this.spellStripPrice) {
            GlobalInfo.Points -= this.spellStripPrice;
            this.pointsText.setText(GlobalInfo.Points.toString());
            this.animatePoint(this.world.width - 130, this.world.height - 160, -1 * this.spellStripPrice);
        } else {
            var count = GlobalInfo.GetSpellStripCount();
            count--;
            if (count < 0)
                return;

            this.spellStripPurchasedCountLabel.text = count > 0 ? count.toString() : '';

            GlobalInfo.SetSpellStripCount(count);
        }

        objects[objects.length - 1].strip(false);
        objects[objects.length - 2].strip(false);
        objects[objects.length - 3].strip(false);

        this.audioSpellStrip.play();
    };

    Level.prototype.checkFinishGirl = function (dropPoint, isUserAction) {
        var _this = this;
        if (this.isFinished)
            return;

        this.goodMovesCount++;
        if (this.goodMovesCount == 11)
            this.setPointsCoef(2);

        if (this.goodMovesCount == 21)
            this.setPointsCoef(3);

        if (this.goodMovesCount == 31)
            this.setPointsCoef(4);

        if (isUserAction) {
            GlobalInfo.Points += 5 * this.pointsCoef;
            this.pointsText.setText(GlobalInfo.Points.toString());
            this.pointsText.visible = true;
            this.pointsTitle.visible = true;

            this.animatePoint(dropPoint.x + 10, dropPoint.y, 5 * this.pointsCoef);
        }

        var showSpells = (GlobalInfo.GirlsCount >= 6);

        if (!this.spellStripPriceTitle.visible && showSpells && !this.spellsStartedShowing) {
            this.spellsStartedShowing = true;
            this.spellFreezeTime.x = -100;
            this.spellStrip.x = this.world.width + 100;
            this.spellStrip.visible = this.spellFreezeTime.visible = showSpells;

            this.add.tween(this.spellFreezeTime).to({ x: 20 }, 400, null, true);
            this.add.tween(this.spellStrip).to({ x: this.world.width - 20 }, 400, null, true).onComplete.add(function () {
                _this.spellStripPriceTitle.visible = _this.spellFreezeTimePriceTitle.visible = showSpells;
                _this.spellFreezeTimePurchasedCountLabel.visible = _this.spellStripPurchasedCountLabel.visible = showSpells;
            }, this);
        }

        this.spellFreezeTime.inputEnabled = ((GlobalInfo.Points >= this.spellFreezeTimePrice && this.freezeTimeUsedCount < 20) || (GlobalInfo.GetSpellFreezeTimeCount() > 0 && this.freezeTimeUsedCount < 5)) && this.secondsLeft < 50;

        this.spellFreezeTime.alpha = this.spellFreezeTime.inputEnabled ? 1 : 0.3;
        this.updateSpellStripEnable();

        if (this.personParts.filter(function (p) {
            return p.isDragable;
        }).every(function (p) {
            return !p.alive;
        })) {
            if (this.random(2) == 1)
                this.audioWin1.play();
            else
                this.audioWin2.play();

            this.personMouth.setTexture(PIXI.TextureCache['Mouth' + this.random(13)]);

            GlobalInfo.GirlsCount++;
            this.girlsText.setText(GlobalInfo.GirlsCount.toString());
            this.girlsText.visible = true;
            this.girlsTitle.visible = true;

            this.updatePlayerLevel();

            setTimeout(function () {
                _this.personMouth.setTexture(PIXI.TextureCache['Mouth1']);
            }, 700);

            this.buildPlayerTimeout = setTimeout(function () {
                _this.buildPlayer();

                _this.updateSpellStripEnable();
            }, 1000);
        }
    };

    Level.prototype.updateSpellStripEnable = function () {
        this.spellStrip.inputEnabled = (GlobalInfo.Points >= this.spellStripPrice || GlobalInfo.GetSpellStripCount() > 0) && this.personParts.filter(function (p) {
            return p.isDragable && p.alive;
        }).length > 3;
        this.spellStrip.alpha = this.spellStrip.inputEnabled ? 1 : 0.3;
    };

    Level.prototype.finish = function () {
        var _this = this;
        this.isFinished = true;

        clearInterval(this.finishInterval);
        clearTimeout(this.buildPlayerTimeout);
        GlobalInfo.SaveBestScores();

        this.secondsLeft = this.TOTAL_TIME;
        this.pointsCoef = 1;

        setTimeout(function () {
            _this.audioWin1.destroy(true);
            _this.audioWin2.destroy(true);
            _this.audioLose.destroy(true);
            _this.audioWarning.destroy(true);
            _this.audioTick.destroy(true);
            _this.audioFinish.destroy(true);
            _this.audioSpellFreeze.destroy(true);
            _this.audioSpellStrip.destroy(true);
        }, 2000);

        setTimeout(function () {
            return _this.game.state.start('GameResults', true, false);
        }, 500);
    };

    Level.prototype.updatePlayerLevel = function () {
        var level;
        var oldLevel = GlobalInfo.Level;

        for (var i in this.levels) {
            level = this.levels[i];

            if (GlobalInfo.GirlsCount >= level.GirlsCount) {
                GlobalInfo.Level = level;
            } else {
                break;
            }
        }

        var isChanged = (GlobalInfo.Level && (!oldLevel || oldLevel.ID < GlobalInfo.Level.ID));

        if (isChanged) {
            this.levelText.setText(GlobalInfo.Level.Name);
            this.levelTitle.setText('LEVEL ' + GlobalInfo.Level.ID);

            var sound = new Phaser.Sound(this.game, GlobalInfo.Level.AudioName + (GlobalInfo.Level.AudioName == 'LevelSexy' ? this.random(2).toString() : ''), 0.3);
            sound.play().onMarkerComplete.add(function () {
                return sound.destroy();
            });

            var originalX = 20;
            var originalY = 20;

            this.levelText.position.setTo(this.world.width / 2, 110);
            this.levelText.fontSize = 70;
            this.levelText.anchor.x = 0.5;

            this.game.add.tween(this.levelText).to({ fontSize: 40 }, 300, null, true, 1000, 0);
            this.game.add.tween(this.levelText.position).to({ x: originalX, y: originalY }, 300, null, true, 1000, 0);
            this.game.add.tween(this.levelText.anchor).to({ x: 0 }, 300, null, true, 1000, 0);
        }
    };

    Level.prototype.setPointsCoef = function (coef) {
        var isChanged = this.pointsCoef && this.pointsCoef != coef;
        this.pointsCoef = coef;

        this.pointsCoefTitle.text = coef.toString() + 'X';
        this.pointsCoefTitle.visible = coef > 1;

        if (isChanged) {
            var label = this.add.text(this.world.width / 2, 170, coef.toString() + 'X Points', '');
            label.font = 'Tahoma';
            label.fontSize = 70;
            label.fontWeight = 500;
            label.fill = 'orange';
            label.anchor.x = 0.5;

            this.game.add.tween(label).to({ fontSize: 40, alpha: 0 }, 300, null, true, 500, 0).onComplete.add(function () {
                return label.destroy(true);
            });
        }
    };

    Level.prototype.animatePoint = function (x, y, points, skipFormating) {
        if (typeof skipFormating === "undefined") { skipFormating = false; }
        var label = this.add.text(x, y, skipFormating ? points : (points > 0 ? ('+' + points) : points), '');
        label.font = 'Tahoma';
        label.fontSize = 50;
        label.fontWeight = 500;
        label.fill = skipFormating ? 'skyblue' : 'orange';

        this.game.add.tween(label).to({ y: y - 100, alpha: 0 }, 1000, null, true).onComplete.add(function () {
            label.destroy(true);
        });
    };

    Level.prototype.blinkEyes = function (mode) {
        var _this = this;
        var oldKey = this.personEye.key;
        var blinkTimeout = 100;
        this.personEye.setTexture(PIXI.TextureCache['EyeClosed']);

        if (mode == 1) {
            this.personEye.setTexture(PIXI.TextureCache['EyeWink1']);
            blinkTimeout = 80;
        }

        if (mode == 2) {
            this.personEye.setTexture(PIXI.TextureCache['EyeWink2']);
            blinkTimeout = 80;
        }

        setTimeout(function () {
            _this.personEye.setTexture(PIXI.TextureCache[oldKey]);
        }, blinkTimeout);
    };

    Level.prototype.random = function (max) {
        return new Random().Next(max) + 1;
    };
    return Level;
})(Phaser.State);

var GameResults = (function (_super) {
    __extends(GameResults, _super);
    function GameResults() {
        _super.apply(this, arguments);
        this.buySpellFreezeTimeCount = 5;
        this.buySpellStripCount = 5;
    }
    GameResults.prototype.create = function () {
        var _this = this;
        var startButton = this.add.text(this.world.width / 2, this.world.height - 60, 'TAP THE GIRL TO PLAY AGAIN', '');
        startButton.anchor.set(0.5, 0.5);
        startButton.fill = 'black';
        startButton.fontSize = 30;
        startButton.font = 'Tahoma';
        startButton.alpha = 0.3;
        startButton.visible = false;

        var marginTop = -200;

        var level = GlobalInfo.GetLevel();
        if (level.ID) {
            var leaderboard = this.add.button(this.world.width / 2, this.world.height / 2 + 290, 'Leaderboard', function () {
            }, this, 1, 0, 1, 0);
            leaderboard.anchor.setTo(0.5, 0.5);
            leaderboard.events.onInputDown.add(function () {
                Extensions.ShowLeaderboard('all');
                return false;
            });

            this.createResults(170, 'BEST SCORE:', level.ID, level.Name, GlobalInfo.GetBestScoreGirlsCount(), GlobalInfo.GetBestScorePoints());
        }

        if (GlobalInfo.Level) {
            var sharePanel = this.add.button(this.world.width / 2, this.world.height / 2 - 490, 'Share', function () {
            }, this, 1, 0, 1, 0);
            sharePanel.anchor.setTo(0.5, 0);
            sharePanel.events.onInputDown.add(function () {
                Extensions.ShowShare('Stripped ' + GlobalInfo.GirlsCount + ' Girls! Challenge Me! #stripme');
                return false;
            });

            this.createResults(-470, 'GAME RESULTS:', GlobalInfo.Level.ID, GlobalInfo.Level.Name, GlobalInfo.GirlsCount, GlobalInfo.Points);
        }

        var logoGirl = this.add.image(this.world.width / 2, this.world.height / 2 - 30, 'LogoGirl');
        logoGirl.anchor.set(0.5, 0.5);
        logoGirl.inputEnabled = true;
        logoGirl.alpha = 0;
        this.game.add.tween(logoGirl).to({ alpha: 1 }, 1000).start();

        setTimeout(function () {
            logoGirl.events.onInputDown.add(function () {
                logoGirl.inputEnabled = false;

                _this.game.add.tween(logoGirl.scale).to({ x: 3, y: 3 }, 700, null, true);
                setTimeout(function () {
                    return _this.game.state.start('Level', true, false, true);
                }, 600);
            });

            startButton.visible = true;
        }, 3000);

        if (!Config.HidePurchases) {
            var donateMe = this.add.button(this.world.width / 2 + 60, this.world.height / 2 - 240, 'DonateMe', function () {
            }, this, 1, 0, 1, 0);
            donateMe.events.onInputDown.add(function () {
                donateMe.destroy();

                Extensions.DonateMe(function () {
                    GlobalInfo.AddDonateCount();

                    _this.giveGift();

                    Extensions.ShowLeaderboard('awesome');

                    navigator.notification.alert('You are in Awesome People list. Also we have some gifts for you, check out your new spells: 4x Freeze Time & 4x Strip. Good Luck!', function () {
                    }, 'Thanks');
                });
                return false;
            });
            donateMe.alpha = 0;
            this.add.tween(donateMe).to({ alpha: 0.7 }, 700, null, true, 2000);

            var spellFreezeTime = this.add.button(70, this.world.height / 2 - 160, 'SpellFreezeTime', this.buyFreezeTime, this, 1, 0, 2, 0);
            spellFreezeTime.alpha = 0;

            var spellStrip = this.add.button(70, this.world.height / 2 + 10, 'SpellStrip', this.buyStrip, this, 1, 0, 1, 0);
            spellStrip.alpha = 0;

            this.spellFreezeTimePurchasedCountLabel = this.add.text(148, this.world.height / 2 - 80, GlobalInfo.GetSpellFreezeTimeCount() ? GlobalInfo.GetSpellFreezeTimeCount().toString() : '', '');
            this.spellFreezeTimePurchasedCountLabel.anchor.set(0.5, 0.5);

            this.spellFreezeTimePurchasedCountLabel.fill = 'white';
            this.spellFreezeTimePurchasedCountLabel.setShadow(0, 0, 'rgba(0,0,0,0.9)', 10);
            this.spellFreezeTimePurchasedCountLabel.visible = false;

            this.spellStripPurchasedCountLabel = this.add.text(148, this.world.height / 2 + 85, GlobalInfo.GetSpellStripCount() ? GlobalInfo.GetSpellStripCount().toString() : '', '');
            this.spellStripPurchasedCountLabel.anchor.set(0.5, 0.5);

            this.spellStripPurchasedCountLabel.fill = 'white';
            this.spellStripPurchasedCountLabel.setShadow(0, 0, 'rgba(0,0,0,0.9)', 10);
            this.spellStripPurchasedCountLabel.visible = false;

            var spellFreezeTimeAddLabel = this.add.text(93, this.world.height / 2 - 105, '+', '');
            spellFreezeTimeAddLabel.anchor.set(0.5, 0.5);
            spellFreezeTimeAddLabel.fill = 'white';
            spellFreezeTimeAddLabel.font = 'Tahoma';
            spellFreezeTimeAddLabel.fontSize = 30;
            spellFreezeTimeAddLabel.setShadow(0, 0, 'rgba(0,0,0,0.9)', 5);
            spellFreezeTimeAddLabel.visible = false;

            var spellStripAddLabel = this.add.text(93, this.world.height / 2 + 60, '+', '');
            spellStripAddLabel.anchor.set(0.5, 0.5);
            spellStripAddLabel.fill = 'white';
            spellStripAddLabel.font = 'Tahoma';
            spellStripAddLabel.fontSize = 30;
            spellStripAddLabel.setShadow(0, 0, 'rgba(0,0,0,0.9)', 5);
            spellStripAddLabel.visible = false;

            this.add.tween(spellFreezeTime).to({ alpha: 1 }, 400, null, true, 1000).onComplete.add(function () {
                _this.spellFreezeTimePurchasedCountLabel.visible = true;
                spellFreezeTimeAddLabel.visible = true;
            });
            this.add.tween(spellStrip).to({ alpha: 1 }, 400, null, true, 1200).onComplete.add(function () {
                _this.spellStripPurchasedCountLabel.visible = true;
                spellStripAddLabel.visible = true;
            });
        }
    };

    GameResults.prototype.buyFreezeTime = function () {
        var _this = this;
        Extensions.BuyFreezeTime(this.buySpellFreezeTimeCount, function () {
            var count = GlobalInfo.GetSpellFreezeTimeCount();
            count += _this.buySpellFreezeTimeCount;

            GlobalInfo.SetSpellFreezeTimeCount(count);
            _this.spellFreezeTimePurchasedCountLabel.text = count.toString();
        });
    };

    GameResults.prototype.buyStrip = function () {
        var _this = this;
        Extensions.BuyStrip(this.buySpellStripCount, function () {
            var count = GlobalInfo.GetSpellStripCount();
            count += _this.buySpellStripCount;

            GlobalInfo.SetSpellStripCount(count);
            _this.spellStripPurchasedCountLabel.text = count.toString();
        });
    };

    GameResults.prototype.giveGift = function () {
        var count = GlobalInfo.GetSpellStripCount();
        count += 4;

        GlobalInfo.SetSpellStripCount(count);
        this.spellStripPurchasedCountLabel.text = count.toString();

        count = GlobalInfo.GetSpellFreezeTimeCount();
        count += 4;

        GlobalInfo.SetSpellFreezeTimeCount(count);
        this.spellFreezeTimePurchasedCountLabel.text = count.toString();
    };

    GameResults.prototype.createResults = function (marginTop, title, levelID, levelName, girlsCount, points) {
        var bestScoreTitle = this.add.text(this.world.width / 2, this.world.height / 2 + 20 + marginTop, title, '');
        bestScoreTitle.anchor.set(0.5, 0.5);
        bestScoreTitle.fill = 'black';
        bestScoreTitle.fontSize = 30;
        bestScoreTitle.font = 'Tahoma';
        bestScoreTitle.alpha = 0.6;

        var levelTitle = this.add.text(this.world.width / 2 - 130, this.world.height / 2 + 77 + marginTop, 'LEVEL ' + levelID, '');
        levelTitle.font = 'Tahoma';
        levelTitle.fontSize = 25;
        levelTitle.fill = 'black';
        levelTitle.anchor.set(0, 0);
        levelTitle.alpha = 0.3;

        var pointsTitle = this.add.text(this.world.width / 2 - 130, this.world.height / 2 + 137 + marginTop, 'STRIPPED', '');
        pointsTitle.font = 'Tahoma';
        pointsTitle.fontSize = 25;
        pointsTitle.fill = 'black';
        pointsTitle.anchor.set(0, 0);
        pointsTitle.alpha = 0.3;

        var levelText = this.add.text(this.world.width / 2 + 130, this.world.height / 2 + 77 + marginTop, levelName, '');
        levelText.font = 'Tahoma';
        levelText.fontSize = 25;
        levelText.fill = '#55b919';
        levelText.anchor.set(1, 0);

        var scoreText = this.add.text(this.world.width / 2 + 130, this.world.height / 2 + 137 + marginTop, girlsCount.toString(), '');
        scoreText.font = 'Tahoma';
        scoreText.fontSize = 25;
        scoreText.fill = '#55b919';
        scoreText.anchor.set(1, 0);
    };
    return GameResults;
})(Phaser.State);

var PersonPart = (function (_super) {
    __extends(PersonPart, _super);
    function PersonPart(game, originalX, originalY, originalZ, resKey, isDragable, dropObject, HelpPointer, destroyCallback, invalidMoveCallback) {
        if (typeof isDragable === "undefined") { isDragable = false; }
        var _this = this;
        _super.call(this, game, originalX, originalY, resKey);
        this.originalX = originalX;
        this.originalY = originalY;
        this.originalZ = originalZ;
        this.isDragable = isDragable;
        this.dropObject = dropObject;
        this.HelpPointer = HelpPointer;
        this.destroyCallback = destroyCallback;
        this.invalidMoveCallback = invalidMoveCallback;

        game.add.existing(this);

        this.z = originalZ;

        if (isDragable) {
            this.audioCorrect = game.add.audio('strip', 0.5);
            this.audioWarning = game.add.audio('warning', 0.5);

            this.inputEnabled = true;
            this.input.enableDrag();
            this.events.onDragStart.add(this.onDragStart, this);
            this.events.onDragStop.add(this.onDragStop, this);
            this.events.onInputOver.add(this.onInputOver, this);
            this.events.onInputOut.add(this.onInputOut, this);
            this.events.onInputUp.add(this.onInputOut, this);

            var moveDirection = (this.dropObject.position.x < this.game.width / 2) ? -1 : 1;

            dropObject.inputEnabled = true;
            dropObject.events.onInputDown.add(function () {
                _this.HelpPointer.position.setTo(_this.x, _this.y + 120);
                _this.HelpPointer.visible = true;
                _this.game.add.tween(_this.HelpPointer).to({ x: _this.x + _this.width / 2 - _this.HelpPointer.width / 2 - 30 + moveDirection * 300 }, 1000, Phaser.Easing.Back.InOut, true, 0, 0).onComplete.add(function () {
                    return _this.HelpPointer.visible = false;
                });
            });
        }
    }
    PersonPart.prototype.onDragStart = function (sprite, pointer) {
    };

    PersonPart.prototype.onDragStop = function (sprite, pointer) {
        if ((this.dropObject.position.x < this.game.width / 2) && (this.position.x > this.dropObject.position.x) || (this.dropObject.position.x > this.game.width / 2) && (this.position.x + this.width < this.dropObject.position.x + this.dropObject.width)) {
            this.position.setTo(this.originalX, this.originalY);
            this.audioWarning.play();

            this.invalidMoveCallback && this.invalidMoveCallback();
            return;
        }

        this.strip();
    };

    PersonPart.prototype.strip = function (isUserAction) {
        var _this = this;
        if (typeof isUserAction === "undefined") { isUserAction = true; }
        this.destroy();
        this.dropObject.destroy();
        this.audioCorrect.play().onMarkerComplete.add(function () {
            return _this.destroy();
        });

        this.destroyCallback && this.destroyCallback(this.dropObject.position, isUserAction);
    };

    PersonPart.prototype.onInputOver = function () {
        this.alpha = 0.7;
    };

    PersonPart.prototype.onInputOut = function () {
        this.alpha = 1;
    };

    PersonPart.prototype.destroyAudios = function () {
        if (this.audioCorrect)
            this.audioCorrect.destroy(true);

        if (this.audioWarning)
            this.audioWarning.destroy(true);
    };

    PersonPart.prototype.resetPosition = function () {
        this.x = this.originalX;
        this.y = this.originalY;
        this.z = this.originalZ;
    };
    return PersonPart;
})(Phaser.Sprite);

var game = new Game();

var Random = (function () {
    function Random() {
    }
    Random.prototype.Next = function (maxRange) {
        return Math.floor((Math.random() * maxRange));
    };
    return Random;
})();
//# sourceMappingURL=Game.js.map
